<?php
if ( post_password_required() ) {
	return;
}

$comments_number = get_comments_number();
?>

<!-- Comments -->
<div id="comments" class="alvaro-comments">
	<?php if ( have_comments() ) { ?>
		<?php if( alvaro()->page_layout['comments-as-reviews'] === true ){ ?>
			<h5><?php echo esc_html( sprintf( _nx( 'One review', '%1$s Reviews', $comments_number, 'review title', 'alvaro' ), number_format_i18n($comments_number) ) ); ?></h5>
		<?php } else {
		?>
			<h5><span>
				<?php
				printf(
					/* translators: 1: number of comments, 2: post title */
					_nx(
						'%1$s Reply to &ldquo;%2$s&rdquo;',
						'%1$s Comments',
						$comments_number,
						'comments title',
						'alvaro'
					),
					number_format_i18n( $comments_number ),
					get_the_title()
				);

				?>
			</span></h5>
		<?php } ?>

		<ul class="comments-list">
			<?php
			$comments = wp_list_comments( array(
				'style'       	=> 'ul',
				'callback'	  	=> array( alvaro(), 'comment_template' ),
				'reply_text'  	=> esc_html__('Reply', 'alvaro'),
				'short_ping'  	=> true,
				'avatar_size' 	=> 58
			) );
			?>
		</ul>

		<?php the_comments_pagination( array(
			'prev_text' => '<span class="screen-reader-text">&raquo;' . __( 'Previous', 'alvaro' ) . '</span>',
			'next_text' => '<span class="screen-reader-text">' . __( 'Next', 'alvaro' ) . '&laquo;</span>',
		) ); ?>

	<?php } ?> 
	
	<?php
		// If comments are closed and there are comments, let's leave a little note, shall we?
		if ( ! comments_open() && get_comments_number() ) : ?>
		
		<?php if( alvaro()->page_layout['comments-as-reviews'] === true ){ ?>
			<p class="no-comments"><?php esc_html_e('Reviews are closed', 'alvaro'); ?></p>
		<?php }else{ ?>
			<p class="no-comments"><?php esc_html_e('Comments are closed', 'alvaro'); ?></p>
		<?php } ?>
		
	<?php endif; ?>

	<div class="comment-form">
		<?php
		$commenter = wp_get_current_commenter();
		$req = get_option( 'require_name_email' );
		$aria_req = ( $req ? " aria-required='true'" : '' );

		$commentForm_args = array(
		    'label_submit' => esc_html__('Post Comment', 'alvaro'),
		    'title_reply' => '<span>' . esc_html__('Join the discussion', 'alvaro') . '</span>',
		    'title_reply_to' => esc_html__('Leave a Reply to %s', 'alvaro'),
		    'cancel_reply_link' => esc_html__('Cancel Reply', 'alvaro'),
		    'logged_in_as' => '',
		    'comment_notes_before' => '',
		    'comment_notes_after' => '',
		    'comment_field' => '<textarea id="comment" name="comment" rows="9" placeholder="' . ( esc_attr__('Comment', 'alvaro') ) . '" ' . $aria_req . '></textarea>',
		    'fields' => apply_filters( 'comment_form_default_fields', array(
				'author' =>
					'<div class="row"><fieldset class="col-lg-6 col-sm-12"><input id="author" name="author" placeholder="' . ( esc_attr__('Name', 'alvaro') ) . '" type="text" value="' . esc_attr( $commenter['comment_author'] ) .
					'"' . $aria_req . ' /></fieldset>',

				'email' => '<fieldset class="col-lg-6 col-sm-12"><input id="email" name="email" type="text" placeholder="' . ( esc_attr__('Email', 'alvaro') ) . '" value="' . esc_attr(  $commenter['comment_author_email'] ) .
					'"' . $aria_req . ' /></fieldset></div>',
					
				'website' => '<div class="row"><fieldset class="col-lg-12"><input id="url" name="url" type="text" placeholder="' . ( esc_attr__('Website', 'alvaro') ) . '" value="' . esc_attr(  $commenter['comment_author_url'] ) .
					'"' . $aria_req . ' /></fieldset></div>'
			))
		);

		if( alvaro()->page_layout['comments-as-reviews'] === true ) {

			$commentForm_args['comment_notes_after'] = '<fieldset>' . ( alvaro()->get_rating_html( 'rating', esc_html__('Your Review', 'alvaro') ) ) . '</fieldset>';

			$commentForm_args['label_submit'] = esc_html__('Submit', 'alvaro');
			$commentForm_args['title_reply'] = esc_html__('Post your own review', 'alvaro');
		}

		comment_form( $commentForm_args );
		?>
	</div>

	<div class="clearfix"></div>
</div>