<!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
	<meta charset="UTF-8" />
	<meta name="viewport" content="width=device-width, initial-scale=1" />
	<link rel="profile" href="//gmpg.org/xfn/11" />
	<link rel="pingback" href="<?php echo esc_url( get_bloginfo( 'pingback_url' ) ); ?>" />

	<?php wp_site_icon(); ?>
	<?php wp_head(); ?>
</head>

<body <?php body_class(); ?>>

<!-- Header ========== -->

<header>

	<div class="container-fluid-extender">
		<?php if( isset(alvaro()->page_layout['rev_slider_alias']) && alvaro()->page_layout['rev_slider_alias'] && function_exists('putRevslider') && is_front_page() ){ ?>
		
		<section class="alvaro-slider-top">
			<?php putRevslider( alvaro()->page_layout['rev_slider_alias'] ); ?>
		</section>
		
		<?php } ?>
		
		<?php 
		if( !isset(alvaro()->page_layout['rev_slider_alias']) || alvaro()->page_layout['rev_slider_alias'] == '' || alvaro()->page_layout['rev_slider_alias'] == '0' ){  
			if ( get_theme_mod( 'header_bg' ) ) {
				$header_bg = get_theme_mod( 'header_bg' );
			}
		?>
			
			<div class="alvaro_header_bg_wrapper" <?php echo isset($header_bg) && $header_bg != '' ? 'style="background: transparent url(' . esc_url( $header_bg ) . ') no-repeat scroll center top / cover;"' : ''; ?>>
			
		<?php }else if( alvaro()->page_layout['rev_slider_alias'] != '' ) { ?>
			<div class="alvaro_header_wrapper">
		<?php } ?>
		
		
		<section class="header-top">

			<div class="container-fluid">
				<div class="alvaro-top-left">
					<?php
					if ( class_exists( 'woocommerce' ) ) {
						$my_account_page_id = get_option('woocommerce_myaccount_page_id');
						if ( is_user_logged_in() ) {
							$logout_url = wp_logout_url( get_permalink( $my_account_page_id ) );
							
							if ( get_option( 'woocommerce_force_ssl_checkout' ) == 'yes' )
								$logout_url = str_replace( 'http:', 'https:', $logout_url );
						?>
							<a href="<?php echo esc_url(get_permalink( $my_account_page_id )); ?>" title="<?php esc_attr_e('My Account', 'alvaro'); ?>"><?php esc_html_e('My Account', 'alvaro'); ?></a>
							<span>/</span>
							<a href="<?php echo esc_url( $logout_url ); ?>" title="<?php esc_attr_e('Sign Out','alvaro'); ?>"><?php esc_html_e('Sign Out', 'alvaro'); ?></a>
						<?php } else { ?>
							<a href="<?php echo esc_url(get_permalink( $my_account_page_id )); ?>" title="<?php esc_attr_e('Login / Register', 'alvaro'); ?>"><?php esc_html_e('Login / Register', 'alvaro'); ?></a>
						<?php } ?>
					<?php } ?>
				</div>
				<div class="alvaro-top-right">
					<?php if ( class_exists( 'YITH_WCWL') ) {
						$wcwl = new YITH_WCWL($details = '' );
						$wishlist_page_link = esc_url( site_url() . '/wishlist/' );
					?>
					<a href="<?php echo esc_url( $wishlist_page_link ); ?>" class="alvaro-wishlist"><?php esc_html_e('Wishlist', 'alvaro');?> [<?php echo esc_html( $wcwl->count_products() ); ?>]</a>
					<?php } ?>
					
					<?php if ( class_exists( 'woocommerce' ) ) { ?>
					<a href="<?php echo get_permalink( wc_get_page_id( 'cart' ) ); ?>"><i class="mi-icon mi-icon-cart5"></i> [<?php echo sprintf(_n('%d', '%d',  WC()->cart->cart_contents_count, 'alvaro'), WC()->cart->cart_contents_count);?>] <?php echo WC()->cart->get_cart_total(); ?></a>
					<?php } ?>
				</div>
			</div>

		</section>
		<section class="header-nav">
			<div class="container-fluid">
				<div class="alvaro-responsive-menu">
					<a class="logo" href="<?php echo esc_url( home_url('/') ); ?>" title="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>">
						<?php if ( get_theme_mod( 'logo' ) ) { ?>
							<img src="<?php echo esc_url( get_theme_mod( 'logo' ) ); ?>" alt="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>">
						<?php } else {
							?>
							<img src="<?php echo esc_url( get_template_directory_uri() . '/images/logo.png' ); ?>" alt="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>">
						<?php } ?>
					</a>
					<button id="alvaro-menu-button"><?php esc_html_e('Menu', 'alvaro');?></button>
				</div>

				<nav class="alvaro-menu clearfix">

					<?php
					//render left navigation
					wp_nav_menu(array(
				        'menu'            	=> alvaro()->alias . '-main-left-menu',
				        'menu_class'      	=> 'main-left-menu',
				        'container'			=> '',
				        'echo'            	=> true,
				        'theme_location' 	=> alvaro()->alias . '-main-left-menu',
				        'fallback_cb'		=> ''
				    ));
					?>

					<a class="logo center-logo" href="<?php echo esc_url( home_url('/') ); ?>" title="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>">
						<?php if ( get_theme_mod( 'logo' ) ) { ?>
							<img src="<?php echo esc_url( get_theme_mod( 'logo' ) ); ?>" alt="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>">
						<?php } else {
							?>
							<img src="<?php echo esc_url( get_template_directory_uri() . '/images/logo.png' ); ?>" alt="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>">
						<?php } ?>
					</a>

					<?php
					//render right navigation
					wp_nav_menu(array(
				        'menu'            	=> alvaro()->alias . '-main-right-menu',
				        'menu_class'      	=> 'main-right-menu',
				        'container'			=> '',
				        'echo'            	=> true,
				        'theme_location' 	=> alvaro()->alias . '-main-right-menu',
				        'fallback_cb'		=> ''
				    ));
					?>

				</nav>

			</div>
		</section>

		<?php //if(!is_front_page()) { ?>
		<?php if( !isset(alvaro()->page_layout['rev_slider_alias']) || alvaro()->page_layout['rev_slider_alias'] == '' || alvaro()->page_layout['rev_slider_alias'] == '0' ){ ?>
		<section class="alvaro-title-breadcrumbs-section">
			<div class="container-fluid">
				<?php if ( (function_exists('is_shop') && (is_shop() || is_product_category() || is_product_tag() || is_product())) || is_search() ) { ?>
					<h1 class="woocommerce-products-header__title page-title alvaro-page-title"><?php woocommerce_page_title(); ?></h1>
				<?php } else if ( (is_archive() || is_author() || is_category() || is_home() || is_single() || is_tag()) && 'post' == get_post_type() ) { ?>
					<h1 class="alvaro-page-title"><?php _e('Blog', 'alvaro'); ?></h1>
				<?php } else if ( (is_archive() || is_single() || is_category() || is_tag()) && 'camping_location' == get_post_type() ) { ?>
					<h1 class="alvaro-page-title">
						<?php echo get_theme_mod( 'camping_page' ) > 0 ? get_the_title(get_theme_mod( 'camping_page' )) : ( get_the_title(alvaro()->defaults_theme['camping_page']) != '' ? get_the_title(alvaro()->defaults_theme['camping_page']) : __('Camping', 'alvaro') ); ?>
					</h1>
				<?php } else if ( (is_archive() || is_single() || is_category() || is_tag()) && 'fish_species' == get_post_type() ) { ?>
					<h1 class="alvaro-page-title">
						<?php echo get_theme_mod( 'species_page' ) > 0 ? get_the_title(get_theme_mod( 'species_page' )) : ( get_the_title(alvaro()->defaults_theme['species_page']) != '' ? get_the_title(alvaro()->defaults_theme['species_page']) : __('Species', 'alvaro') ); ?>
					</h1>
				<?php } else if ( is_404() ) { ?>
					<h1 class="alvaro-page-title">
						<?php esc_html_e('Page Not Found', 'alvaro'); ?>
					</h1>					
				<?php } else { ?>
					<h1 class="alvaro-page-title"><?php the_title(); ?></h1>
				<?php } ?>
			</div>
		</section>
		<?php } ?>
		

		</div>

	</div>

</header>
