<?php
/**
 * @package WordPress
 * @subpackage:
 *	Name: 	alvaro Theme
 *	Alias: 	alvaro
 *	Author: AA-Team
 *	Name: 	http://themeforest.net/user/AA-Team/portfolio
 *  Template Name: Blog
 *
**/

global $tag, $cat, $paged;
get_header();

$blog_list_type = get_theme_mod('blog_layout', alvaro()->defaults_theme['blog_layout']);  
?>
<!-- Page Content ==== -->



<div class="alvaro-wrapper">
	<div class="container-fluid-extender">

		<section>
			<div class="container-fluid">
				<div class="row">
					
					<?php if( $blog_list_type != 'alternate' ) { ?>
						<?php alvaro()->print_sidebar( 'main-sidebar', 'left' )?>
					<?php } ?>

					<div class="<?php $blog_list_type == 'alternate' ? alvaro()->content_class('main-sidebar', 'echo', 'col-lg-12 col-md-12 inner-content') : alvaro()->content_class('main-sidebar'); ?>">
						<section id="<?php echo esc_attr($blog_list_type == 'alternate' ? 'alvaro_blog_list' : 'alvaro-blog-list-page'); ?>">
							<?php if( isset($cat) && trim($cat) != '' ) { ?>
								<h1 class="alvaro-title">
									<?php printf( esc_html__( 'Articles posted in %s', 'alvaro' ), get_cat_name(get_query_var('cat'))); ?>
								</h1>
								<hr />
							<?php }else if( isset($tag) && trim($tag) != '' ) { ?>
								<h1 class="alvaro-title">
									<?php printf( esc_html__( 'Articles tagged with "%s"', 'alvaro' ), single_tag_title(false, false)); ?>
								</h1>
								<hr />
							<?php }else{ ?>
								<?php echo is_archive() ? '<h1 class="alvaro-title">' . get_the_archive_title() . '</h1><hr />' : ''; ?>
							<?php } ?>
							
							<?php if( $blog_list_type != 'alternate' ) { ?>
							<ul class="alvaro-blog-list">
							<?php } ?>
							
								<?php
									if( !is_archive() ) {
										$args = array(
											'post_type' => 'post',
											'paged' => $paged,
										);
			
										if( isset($tag) && trim($tag) != "" ){
											$args['tag'] = $tag;
										}
										if( isset($cat) && trim($cat) != "" ){
											$args['cat'] = $cat;
										}
										query_posts($args);
									}
								?>
								<?php
								if( have_posts() ) : while( have_posts() ) : the_post();
								$format = get_post_format();
								?>
								
								<?php if( $blog_list_type == 'alternate' ) { ?>
									<div class="alvaro-blog-item  col-lg-5 col-md-5 col-sm-5 col-xs-12 ">
										<div class="row">
											<div class="col-lg-<?php echo has_post_thumbnail() ? 5 : 12; ?> alvaro-alternate-bheight">
												<p class="alvaro_blog_list_date"><?php echo get_the_date(); ?></p>
												<h2><a href="<?php echo esc_url(get_permalink()) ?>" rel="bookmark"><?php the_title(); ?></a></h2>
												<p class="alvaro_blog_list_comments"><?php comments_number( 0, 1, "%" ); ?></p>
											</div>
											<?php if( has_post_thumbnail() ) { ?>
											<div class="col-lg-7">
												<div class="alvaro_blog_list_img">
													<a href="<?php echo esc_url(get_permalink()) ?>" rel="bookmark"><?php the_post_thumbnail( 'medium' ); ?></a>
												</div>
											</div>
											<?php } ?>
										</div>
									</div>
								<?php }else{ ?>
								
									<li <?php post_class(); ?>>
										
									<div class="alvaro-post-date alvaro-col-meta">
										<span class="post-misc-date">
											<span><?php esc_html( the_time('j') ); ?></span>
											<?php esc_html( the_time('M Y') ); ?>
										</span>
										<?php if( comments_open() ) { ?>
										<span class="post-misc-comments">
											<?php comments_popup_link(esc_html__('0', 'alvaro'), esc_html__('1', 'alvaro'), esc_html__('%', 'alvaro'), 'comments-link', esc_html__('disabled comments', 'alvaro')); ?>
										</span>
										<?php } ?>
									</div>
										
										<div class="alvaro-col-content">
											<?php if( $format == 'gallery' && has_shortcode( get_the_content(), 'gallery' ) ) {
										
												$gallery_img_ids = alvaro()->get_gallery_attachments();
												if( count($gallery_img_ids) > 0 ) {
											?>
											
												<ul class="alvaro-gallery">
												<?php foreach( $gallery_img_ids as $img_id ) { ?>
													<li class="item" data-imageid="<?php echo esc_attr($img_id);?>">
														<?php echo wp_get_attachment_image( $img_id, 'decoElite-blog-featured-image' ); ?>
													</li>
												<?php } ?>
												</ul>
												
											<?php }else if( has_post_thumbnail() ) { ?>
												
												<a class="alvaro-featured-canvas" href="<?php echo esc_url(get_permalink()) ?>">
													<?php the_post_thumbnail( 'large' ); ?>
												</a>
												
											<?php
												}
											
											}else if( $format == 'video' ) {
											?>
												
												<?php if( has_post_thumbnail() ) { ?>
													<a class="alvaro-featured-canvas" href="<?php echo esc_url(get_permalink()) ?>">
														<?php the_post_thumbnail( 'large' ); ?>
													</a>
												<?php } ?>
												
											<?php } ?>
											
											<?php if( !in_array($format, array('gallery', 'video', 'image')) && has_post_thumbnail() ) { ?>
												<a class="alvaro-featured-canvas" href="<?php echo esc_url(get_permalink()) ?>">
													<?php the_post_thumbnail( 'large' ); ?>
												</a>
											<?php } ?>
											
											<?php if( !has_post_format( 'quote' ) && !has_post_format('aside') ) { ?>
												<?php if( has_post_format( 'link' ) ) { ?>
													<h3>
														<a href="<?php echo esc_url( alvaro()->get_link_url() ); ?>" rel="bookmark">
															<?php the_title(); ?>
														</a>
													</h3>
												<?php }else{ ?>
													<h3 class="alvaro-title">
														<a href="<?php echo esc_url(get_permalink()) ?>" rel="bookmark">
															<?php the_title(); ?>
														</a>
													</h3>
												<?php } ?>
											<?php } ?>
	
											<div class="alvaro-categories-post-author">
												<?php echo get_the_category_list(", "); ?>
											</div>
											<div class="alvaro-post-author">
												<?php the_author_posts_link(); ?>
											</div>
											
											<?php if( is_sticky() ) { ?>
												<a href="<?php the_permalink(); ?>" class="sticky_post" title="<?php esc_attr_e('Sticky post', 'alvaro'); ?>"></a>
											<?php } ?>
											
											<?php if( has_post_format( 'image' ) ) { ?>
												
												<?php the_content(); ?>
												
											<?php }else if( has_post_format( 'quote' ) ) { ?>
												<div class="alvaro-post-content">
													<?php the_content(); ?>
													
													<?php if( !in_array($format, array('link', 'quote', 'aside', 'status' )) ) { ?>
														<a href="<?php echo esc_url( get_permalink() ); ?>" class="read-more">
															<?php esc_html_e('Read More', 'alvaro');?>
														</a>
													<?php } ?>
												</div>
											<?php }else if( has_post_format('aside') ) { ?>
												<div class="alvaro-post-content aside">
													<?php the_content(); ?>
													
													<?php if( !in_array($format, array('link', 'quote', 'aside', 'status' )) ) { ?>
														<a href="<?php echo esc_url( get_permalink() ); ?>" class="read-more">
															<?php esc_html_e('Read More', 'alvaro');?>
														</a>
													<?php } ?>
												</div>
											<?php }else if( in_array($format, array('video', 'audio', 'status')) ) { ?>
												<div class="alvaro-post-content">
													<?php the_content(); ?>
													
													<?php if( !in_array($format, array('link', 'quote', 'aside', 'status' )) ) { ?>
														<a href="<?php echo esc_url( get_permalink() ); ?>" class="read-more">
															<?php esc_html_e('Read More', 'alvaro');?>
														</a>
													<?php } ?>
												</div>
											<?php }else if( in_array($format, array('chat')) ) { ?>
												<div class="alvaro-post-content">
													<?php the_excerpt(); ?>
												</div>
											<?php }else if( $format == '' ){ ?>
												<div class="alvaro-post-content">
													<?php
											        if( strpos( $post->post_content, '<!--more-->' ) ) {
											            the_content( __( 'Read More', 'alvaro' ) );
											        }
											        else {
											            the_excerpt();
														echo '<a href="' . ( esc_url(get_permalink()) ) . '" class="more-link"> ' . ( __('Read More', 'alvaro') ) . ' </a>';
											        }
													?>
												</div>
											<?php } ?>
											
											<?php if( has_post_format( 'link' ) ) {
												
												echo '<div class="alvaro-post-content"><a href="' . esc_url( alvaro()->get_link_url() ) . '" rel="bookmark" class="link">' . esc_url( alvaro()->get_link_url() ) . '</a></div>';
												
											}
											?>
										</div>
									</li>
								<?php } ?>
								<?php endwhile; endif; ?>
								
							<?php if( $blog_list_type == 'alternate' ) { ?>
								
								<?php if( !have_posts() ):?>
									<?php esc_html_e('No Blog Entries', 'alvaro'); ?>
								<?php endif; ?>
								
							<?php }else{ ?>
								
								<?php if( !have_posts() ):?>
									<li>
										<?php esc_html_e('No Blog Entries', 'alvaro'); ?>
									</li>
								<?php endif;?>
							</ul>
							
							<?php } ?>
		
							<!-- Paging -->
							<?php if( $wp_query->post_count < $wp_query->found_posts ) { ?>
							<div class="blog_row">
								<nav class="post-pagination woocommerce-pagination clear">
								<!-- Pagination -->
								<?php
									$big = 999999999; // need an unlikely integer
									echo paginate_links( array(
										'base'		=> str_replace( $big, '%#%', esc_url( get_pagenum_link( $big ) ) ),
										'format'	=> '?paged=%#%',
										'current'	=> max( 1, get_query_var('paged') ),
										'total'		=> $wp_query->max_num_pages,
										'prev_next'	=> false,
										'type'		=> 'list'
									) );
									$paged = intval(get_query_var('paged'));
									$max_page = intval( $wp_query->max_num_pages );
									$posts_count = intval( $wp_query->found_posts );
									if( empty( $paged ) || $paged == 0 ) {
										$paged = 1;
									}
								?>
								</nav>
							</div>
							<?php } ?>
							
							<?php wp_reset_query(); ?>
						</section>
						
					</div>
					
					<?php if( $blog_list_type != 'alternate' ) { ?>
						<?php alvaro()->print_sidebar( 'main-sidebar', 'right' )?>
					<?php } ?>

				</div>
			</div>
		</section>

	</div>
</div>
<?php get_footer();