<?php  
/**
 * @package WordPress
 * @subpackage:
 *	Name: 	alvaro Theme
 *	Alias: 	alvaro
 *	Author: AA-Team
 *	Name: 	http://themeforest.net/user/AA-Team/portfolio
 *	
**/
get_header(); ?>

<!-- Page Content ==== -->

<div class="alvaro-wrapper">
	<div class="container-fluid-extender">

		<section>
			<div class="container-fluid">
				<div class="row">

					<?php alvaro()->print_sidebar( 'main-sidebar', 'left' )?>

					<div class="<?php alvaro()->content_class('main-sidebar')?>">
						<?php if ( have_posts() ) : ?>
							<?php while( have_posts() ) : the_post(); ?>

								<div class="page-content">
									<div class="alvaro-post-date alvaro-col-meta">
										<span class="post-misc-date">
											<span><?php esc_html( the_time('j') ); ?></span>
											<?php esc_html( the_time('M Y') ); ?>
										</span>
										<?php if( comments_open() ) { ?>
										<span class="post-misc-comments">
											<?php comments_popup_link(esc_html__('0', 'alvaro'), esc_html__('1', 'alvaro'), esc_html__('%', 'alvaro'), 'comments-link', esc_html__('disabled comments', 'alvaro')); ?>
										</span>
										<?php } ?>
									</div>

									<article class="alvaro-post-content alvaro-col-content">
										
										<?php if( has_post_thumbnail() ) { ?>
											<span class="featured-img"><?php the_post_thumbnail( 'large' ); ?></span>
										<?php } ?>

										<h2 id="post-<?php the_ID(); ?>" <?php post_class('alvaro-post-title'); ?>>
											<?php the_title(); ?>
										</h2>

										<div class="post-misc">


											<?php if( has_category() ) { ?>
												<span class="post-misc-category">
													<?php the_category(' , '); ?>
												</span>
											<?php } ?>

											<span class="post-misc-author">
												<?php the_author_posts_link(); ?>
											</span>

										</div>

										<div class="alvaro-blog-post-content">
										
											<?php the_content(); ?>
											
											<?php wp_link_pages( array(
												'before'      => '<div class="page-links">',
												'after'       => '</div>',
												'link_before' => '<span>',
												'link_after'  => '</span>',
												) );
											?>

											<?php if( has_tag() ) { ?>
												<span class="post-tags">
													<?php the_tags("", " "); ?>
												</span>
											<?php } ?>
										
										</div>

									</article>
									
									<div class="alvaro-offset-120">
										<?php if( trim(get_the_author_meta('description')) != '' ) { ?>
											<div class="alvaro-author-box">
												<div class="alvaro-author-box-avatar">
													<?php echo get_avatar( get_the_author_meta( 'user_email' ), 64 ); ?>
												</div>
												<div class="alvaro-author-details">
													<p class="alvaro-author"><?php the_author_posts_link(); ?></p>
													<p class="alvaro-author-desc"><?php echo get_the_author_meta('description'); ?></p>
												</div>
											</div>
										<?php } ?>
										
										<?php echo shortcode_exists('alvaro_social_share') ? do_shortcode('[alvaro_social_share]') : ''; ?>
										
									</div>

								</div>
								
							<?php endwhile; ?>
						<?php endif; ?>

						<div class="row">
							<div class="col-lg-12">
								<div class="alvaro-offset-120">

									<!-- display about the author info -->
									<?php get_template_part( 'inc/about-author' ); ?>

									<?php comments_template('', true); ?>
								</div>
							</div>
						</div>

					</div>

					<?php alvaro()->print_sidebar( 'main-sidebar', 'right' )?>

				</div>
			</div>
		</section>

	</div>
</div>
<?php get_footer(); ?>