; (function ($) {
	"use strict";

	function initScrollToTop() {
		if ($(window).scrollTop() > 1000 && $(window).width() > 480) {
			$('#alvaro-scroll-top').stop().fadeTo(100, 1);
		} else {
			$('#alvaro-scroll-top').stop().fadeTo(100, 0, function () {
				$(this).hide();
			});
		}
	}

	$(document).ready(function () {

		initScrollToTop();

		// initialise superfish
		$(function () {
			$('.alvaro-menus').superfish({
				delay: 400,
				speed: 'slow',
				autoArrows: false,
				dropShadows: false
			});
		});

		/*======== responsive menu ========*/

		// Watch for resize and show the menu
		$(window).resize(function () {
			var width = window.innerWidth;
			if (width > 991) {
				$(".alvaro-menu").show();
			} else {
				$(".alvaro-menu").hide();
			}
		});

		// Toggle the menu
		$("body").on('click', '#alvaro-menu-button', function () {
			$(".alvaro-menu").slideToggle();
		});

		// Toggle the submenu
		$("body").on('click', 'li.menu-item-has-children', function (e) {
            if (e.target !== this) return;
			$(this).toggleClass('open').find("ul.sub-menu").first().slideToggle();
		});


		// Owl Carousels
		if (typeof $().owlCarousel === "function") { 
			$(".alvaro-recent-testimonials").owlCarousel({
				slideSpeed: 500,
				paginationSpeed: 500,
				singleItem: true,
				autoPlay: false,
				stopOnHover: true,
				navigation: false,
				pagination: true,
				autoHeight: true
			});
	
			$(".alvaro-gallery").owlCarousel({
				slideSpeed: 500,
				paginationSpeed: 500,
				singleItem: true,
				autoPlay: false,
				stopOnHover: true,
				navigation: true,
				pagination: false,
				autoHeight: true
			});
			
			// Fish species products carousel
			$("#alvaro-fish-species-content").find('.woocommerce ul.products').owlCarousel({
				slideSpeed: 500,
				paginationSpeed: 500,
				items: 3,
				itemsDesktop: [1170, 3],
				itemsDesktopSmall: [979, 2],
				itemsTablet: [768, 2],
				itemsTabletSmall: false,
				itemsMobile: [479, 1],
				// Navigation
				navigation: true,
				navigationText: ['<i class="fa fa-chevron-left" aria-hidden="true"></i>', '<i class="fa fa-chevron-right" aria-hidden="true"></i>'],
				// Pagination
				pagination: false,
				autoHeight: true
			});
	
			// Related products carousel
			$("#alvaro_shop_product_details").find('.woocommerce ul.products').owlCarousel({
				slideSpeed: 500,
				paginationSpeed: 500,
				items: 3,
				itemsDesktop: [1170, 3],
				itemsDesktopSmall: [1024, 3],
				itemsTablet: [768, 2],
				itemsTabletSmall: false,
				itemsMobile: [479, 1],
				// Navigation
				navigation: true,
				navigationText: ['<i class="fa fa-chevron-left" aria-hidden="true"></i>', '<i class="fa fa-chevron-right" aria-hidden="true"></i>'],
				// Pagination
				pagination: false,
				autoHeight: true
			});
			
			// Camping location products carousel
			$("#alvaro-camping_location_detail").find('.woocommerce ul.products').owlCarousel({
				slideSpeed: 500,
				paginationSpeed: 500,
				items: 4,
				itemsDesktop: [1170, 4],
				itemsDesktopSmall: [1024, 3],
				itemsTablet: [768, 2],
				itemsTabletSmall: false,
				itemsMobile: [479, 1],
				// Navigation
				navigation: true,
				navigationText: ['<i class="fa fa-chevron-left" aria-hidden="true"></i>', '<i class="fa fa-chevron-right" aria-hidden="true"></i>'],
				// Pagination
				pagination: false,
				autoHeight: true
			});
		}

		// Click event for scroll to top
		$("body").on('click', '#alvaro-scroll-top', function (e) {
			e.preventDefault();

			$('html, body').animate({ scrollTop: 0 }, 800);
			return false;
		});
		
		// Camping location map
		$('a.alvaro-camping-location-pin, a.alvaro-location-pin').on('click', function(e) {
			e.preventDefault();
			
			var gmap_data = $(this).data('camping-map'),
				gmap_append = '<div class="alvaro-camping-location-map"><div class="camping-map-holder"><iframe width="100%" height="600" src="https://maps.google.com/maps?coord='+ gmap_data.lat +','+ gmap_data.lng +'&amp;q='+ gmap_data.address +'&amp;ie=UTF8&amp;z=11&amp;output=embed" frameborder="0" scrolling="no" marginheight="0" marginwidth="0" allowfullscreen></iframe><br /><a href="#"><i class="mi-icon mi-icon-cancel-circle"></i></a></div></div>';
			
			$('html').append(gmap_append);
			
			$('body').css('overflow', 'hidden');
			$('.alvaro-camping-location-map').hide();
			$('.alvaro-camping-location-map').show().css('top', $('html').scrollTop());
		});
		
		$('html').on('click', '.alvaro-camping-location-map', function(e) {
			e.preventDefault();
			
			$(this).remove();
			$('body').css('overflow', 'initial');
		});
	});

	$(window).scroll(function () {
		initScrollToTop();
	});

	$( ".alvaro-fish-list" ).on( "click", ".block-click", function() {
		window.location = jQuery(this).find( "a" ).attr( "href" );
		return false;
	});

})(jQuery);
