<?php
/**
 * @package WordPress
 * @subpackage:
 *	Name: 	alvaro Theme
 *	Alias: 	alvaro
 *	Author: AA-Team
 *	Name: 	http://themeforest.net/user/AA-Team/portfolio
 *  Template Name: Fish Species
 *
**/

get_header();
?>

<!-- Page Content ==== -->

<div class="alvaro-wrapper">
	<div class="container-fluid">

		<section>
			<?php if ( have_posts() ) : ?>
				<?php while( have_posts() ) : the_post(); ?>

					<div class="page-content">
						<div class="row alvaro-fish-list">

						<?php the_content(); ?>

						<?php
						// WP_Query arguments
						$args = array(
							'post_type'              => array( 'fish_species' ),
							'nopaging'               => false,
							'posts_per_page'         => '9',
						);

						// The Query
						$query_species = new WP_Query( $args );

						// The Loop
						if ( $query_species->have_posts() ) {
							while ( $query_species->have_posts() ) {
								$query_species->the_post(); ?>
								<div class="col-sm-12 col-md-4 col-lg-4 alvaro-fish block-click">
									<?php if ( has_post_thumbnail() ) : ?>
										<a class="alvaro-species-image" href="<?php echo esc_url(get_permalink()); ?>" title="<?php the_title_attribute(); ?>">
											<?php the_post_thumbnail(); ?>
										</a>
									<?php endif; ?>

									<div class="alvaro-border-default"></div>
									<div class="alvaro-border-hover"></div>

									<h3 class="alvaro-species-title">
										<a href="<?php echo esc_url(get_permalink()); ?>">
											<?php the_title(); ?>	
										</a>
									</h3>
									<p class="alvaro-species-description"><?php echo get_the_excerpt(); ?></p>
								</div>
								<?php
							}
						} else {
							// no posts found
							esc_html_e( 'No posts to display!', 'alvaro' );
						}

						// Restore original Post Data
						wp_reset_postdata();

						?>
						</div>
					</div>

				<?php endwhile; ?>
			<?php endif; ?>
		</section>

	</div>
</div>
<?php get_footer(); ?>