<?php
/**
 * Single Product tabs
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product/tabs/tabs.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	https://docs.woothemes.com/document/template-structure/
 * @author  WooThemes
 * @package WooCommerce/Templates
 * @version 3.6.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Filter tabs and allow third parties to add their own.
 *
 * Each tab is an array containing title, callback and priority.
 * @see woocommerce_default_product_tabs()
 */
$tabs = apply_filters( 'woocommerce_product_tabs', array() );

if ( ! empty( $tabs ) ) : ?>
	<div class="col-lg-12">
		<div class="alvaro-woocommerce-tabs">
			<?php foreach ( $tabs as $key => $tab ) : ?>
				<div class="alvaro-woocommerce-tab" id="tab-<?php echo esc_attr( $key ); ?>">
					<div class="alvaro-woo-tab-title-container">
						<h3 class="alvaro-woo-tab-title"><?php echo esc_html( $tab['title'] ); ?></h3>
					</div>
					<div class="alvaro-woo-tab-content"><?php call_user_func( $tab['callback'], $key, $tab ); ?></div>
				</div>
			<?php endforeach; ?>
		</div>
	</div>

<?php endif; ?>
