/*!
 * AA-Team slideshow plugin
 */
;(function ( $, window, document, undefined ) {

    $.fn.aatSlideshow = function ( options ) {
        options = $.extend( {}, $.fn.aatSlideshow.options, options );

        return this.each(function () {

            var elm              = $(this),
            	elm_height		= elm.height(),
              	elm_main_images    = elm.find(".aat-slideshow-main-images"),
              	elm_main_width     = elm_main_images.find(">li").eq(0).width(),
              	elm_main_thumbs    = elm.find(".aat-slideshow-thumbnails"),
              	elm_thumbs_height   = 0,
              	elm_thumb_height    = 0,
              	elm_prev_image_btn = elm.find(".aat-slideshow-header-prev"),
              	elm_next_image_btn = elm.find(".aat-slideshow-header-next"),
              	elm_current        = 0,
              	move_to            = 0,
              	elm_total          = 0,
              	thumb_current      = 0,
              	thumb_move_to      = 0,
              	resize_int         = 0,
              	autoPlay  	   	   = false;

            function init()
            {
              elm_main_images.scrollLeft(0);
                elm_main_images.find("li").eq(0).addClass( 'aat-focus' );

              count_elements();
              print_thumbs();
              triggers();
            }

            function swipe() 
            {
                var is_press = false,
                    init_click_pos,
                    c_focused_image = $(),
                    has_to_go_right = 0,
                    has_to_go_left = 0;

                elm_main_images.on('mousedown', elm_main_images.find(".aat-focus"), function(e) {
                    c_focused_image = elm_main_images.find(".aat-focus")
                    is_press = true;
                    init_click_pos = e.pageX;

                    c_focused_image.css('transition', 'none');

                    return false;
                });

                $(document).on('mouseup', elm_main_images.find(".aat-focus"), function() {
                    is_press = false;
                    if( c_focused_image.size() > 0 ){
                      c_focused_image.css('transition', '0.5s');
                      c_focused_image.css('left', '0px');
                    }
                    has_to_go_right = 0;
                    has_to_go_left = 0;
                });

                var dir = 'none',
                    move_after_px = 300;

                elm_main_images.mousemove(function(e) {
                    if (is_press === true) {

                        if (init_click_pos - e.pageX) {

                            c_focused_image.css('left', -(init_click_pos - e.pageX))

                            if (parseInt(c_focused_image.css('left')) < -move_after_px) {
                                has_to_go_right = has_to_go_right + 1;

                                if (has_to_go_right == 1) {
                                    move_to = move_to + 1;

                                    if (move_to >= elm_total) {
                                        move_to = 0;
                                    }

                                    elm_main_images.css({
                                        'left': "-" + (elm_main_width * move_to) + "px",
                                        'transition': 'left 350ms ease-in-out'
                                    });
                                }

                                setTimeout( function() { elm_main_images.find("li").eq(move_to).prev().removeClass('aat-focus'); }, 360 );
                                elm_main_images.find("li").eq(move_to).addClass('aat-focus');

                                elm_current = move_to;

                                count_elements();

                                thumb_move_to = Math.ceil((elm_current + 1) / options.number_thumbs) - 1;
                                move_thumbs();

                            } else if (parseInt(c_focused_image.css('left')) > move_after_px) {

                                has_to_go_left = has_to_go_left + 1;

                                if (has_to_go_left == 1) {
                                    move_to = move_to - 1;
                                    if (move_to < 0) {
                                        move_to = elm_total - 1;
                                    }
                                    elm_main_images.css({
                                        'left': "-" + (elm_main_width * move_to) + "px",
                                        'transition': 'left 350ms ease-in-out'
                                        });
                                    }

                                    setTimeout( function() { elm_main_images.find("li").eq(move_to).next().removeClass('aat-focus'); }, 360 );

                                    elm_main_images.find("li").eq(move_to).addClass('aat-focus');

                                    elm_current = move_to;

                                    count_elements();

                                    thumb_move_to = Math.ceil((elm_current + 1) / options.number_thumbs) - 1;
                                    move_thumbs();

                            }
                        }
                    }
                });
            }

            function print_thumbs()
            { 
              if( options.show_thumbs == 'yes' ){
                elm.addClass("aat-slideshow-with-thumbnails");
              }

              elm_thumbs_height  = elm_main_thumbs.outerHeight(),
              elm_thumb_height   = elm_main_thumbs.find(">li").eq(0).outerHeight();
	
              var margin = ( elm_thumbs_height - ( elm_thumb_height * options.number_thumbs ) ) / options.number_thumbs;
              elm_main_thumbs.find(">li").css({
              	'margin-top': ( margin ) + "px",
                'margin-bottom': ( margin ) + "px"
              });
            }

            function count_elements()
            {
              elm_total = elm_main_images.find(">li").size();

              elm_main_thumbs.find("li.aat-on").removeClass('aat-on');
              elm_main_thumbs.find(">li").eq(elm_current).addClass('aat-on');
            }

            function move(force_move) 
            {
                force_move = force_move ? force_move : false;

                if (typeof(options.onStart) === 'function') options.onStart();

                if (force_move !== true && elm_current == move_to) return;
                
                elm_main_images.css({
                    'left': "-" + (elm_main_images.find(">li").eq(0).width() * move_to) + "px",
                    'transition': 'left 350ms ease-in-out'
                });

                elm_main_images.find(".aat-focus").removeClass("aat-focus");
                elm_main_images.find("li").eq(move_to).addClass('aat-focus');

                elm_current = move_to;

                count_elements();

                thumb_move_to = Math.ceil((elm_current + 1) / options.number_thumbs) - 1;
                move_thumbs();

                if (typeof(options.onEnd) === 'function') options.onEnd();
            }

            function move_thumbs()
            {
              if( thumb_current == thumb_move_to ) return;

              //console.log( elm_thumbs_width * thumb_move_to );

              elm_main_thumbs.css({
                'top': "-" + ( elm_thumbs_height * thumb_move_to ) + "px",
                'transition' : 'top 350ms ease-in-out'
              });

              thumb_current = thumb_move_to;

              //count_elements();
            }

            function responsive_re_init()
            {
              //console.info( 'reinit' );
              if( $(window).width() < 768 ) {
				elm.css('height', '450px');
			  }else{
			  	elm.css('height', elm.data('height'));
			  }
			  
              elm_main_width = elm_main_images.find(">li").eq(0).width(); 
              print_thumbs();
              move( true );
            }

            function enter_fullscreen_mode()
            {
              var fsholder = $('<div class="aat-slideshow-fullscreen-holder" />');

              elm.after("<div class='aat-slideshow-marker' />");
              fsholder.html(elm);
              $('body').append(fsholder); 
              
              responsive_re_init();
              
              options.number_thumbs = Math.floor( elm_thumbs_height / elm_thumb_height );
              print_thumbs();
            }

            function exit_fullscreen_mode()
            { 
              $(".aat-slideshow-marker")
                .before( elm )
                .remove();
                 
			  elm.height(elm_height);
              responsive_re_init();
              
              options.number_thumbs = Math.floor( elm_thumbs_height / elm_thumb_height );
              print_thumbs();
              
              $(".aat-slideshow-fullscreen-holder").remove();
            }
            
            function start_autoPlay()
            { 
            	autoPlay = setInterval(function() {
            		move_to = move_to + 1;
	                if( move_to >= elm_total ){
	                  move_to = 0;
	                }
	
	                move();
            	}, options.autoPlayTimeout);
            }

            function triggers()
            {
              swipe();
              
              if( $(window).width() < 768 ) {
				elm.css('height', '450px');
			  }
              
			  if( options.autoPlay == true ) {
			  	start_autoPlay();
			  }
			  
              elm_prev_image_btn.click( function(e){
                e.preventDefault();
				
				if( options.autoPlay == true ) {
					clearInterval( autoPlay );
				}
				
                move_to = move_to - 1;
                if( move_to < 0 ){
                  move_to = elm_total - 1;
                }

                move();
                
                if( options.autoPlay == true && options.stopOnHover == 'no' ) {
				  	start_autoPlay();
				}
              } );

              elm_next_image_btn.click( function(e){
                e.preventDefault();
				 
				if( options.autoPlay == true ) {
					clearInterval( autoPlay );
				}
				
                move_to = move_to + 1;
                if( move_to >= elm_total ){
                  move_to = 0;
                }

                move();
                
                if( options.autoPlay == true && options.stopOnHover == 'no' ) { 
				  	start_autoPlay();
				}
              } );

              elm_main_thumbs.find(">li").click( function(e){
                e.preventDefault();

                move_to = $(this).index();
                move();
              } );

              elm.find(".aat-slideshow-btn-fullscreen-mode").click( function(e){
                e.preventDefault();

                if( $('body .aat-slideshow-fullscreen-holder').size() == 0 ){
                  enter_fullscreen_mode();
                  $('.aat-slideshow-enter-fullscreen').hide();
                  $('.aat-slideshow-exit-fullscreen').show();
                } else {
                  exit_fullscreen_mode();
                  $('.aat-slideshow-enter-fullscreen').show();
                  $('.aat-slideshow-exit-fullscreen').hide();
                }
              });
              
              if( options.autoPlay == true && options.stopOnHover == 'yes' ) {
	              elm.on('mouseover', function() {
					clearInterval( autoPlay );
	              });
	              elm.on('mouseout', function() {
					start_autoPlay();
	              });
	          }
              
              $(window).resize(function(){
                clearTimeout(resize_int);
                resize_int = setTimeout(function(){
                  	responsive_re_init();
                  	options.number_thumbs = Math.floor( elm_thumbs_height / elm_thumb_height );
              		print_thumbs();
                }, 200);
              })
            }

            init();
        });
    };

    $.fn.aatSlideshow.options = {

        show_thumbs: 'yes',
        number_thumbs: 3,
        swipe: true,
        autoPlay: false,
        autoPlayTimeout: 3000,
        stopOnHover: 'yes',
        onStart: function ( elem, param ) {},
        onEnd: function ( elem, param ) {}
    };

})( jQuery, window, document );