function initAlvaroMap(map_elm) {
	var geocoder = new google.maps.Geocoder();
	
	var customMapType = new google.maps.StyledMapType([
      {
        stylers: [
          {saturation : (map_elm.data('black_and_white') == 'yes' ? -100 : 0)}
        ]
      }
    ], {
      	name: 'Alvaro'
  	});
  	
  	var customMapTypeId = 'alvaro_style';
  	 
  	if( map_elm.data('hide_controls') == 'yes' ) {
  		var map = new google.maps.Map(document.getElementById( map_elm.attr('id') ), {
			zoom: map_elm.data('zoom'),
			panControl: false,
			zoomControl: false,
			mapTypeControl: false,
			scaleControl: false,
			streetViewControl: false,
			overviewMapControl: false
	  	});
  	}else{
  		var map = new google.maps.Map(document.getElementById( map_elm.attr('id') ), {
			zoom: map_elm.data('zoom')
	  	});
  	}
  	
  	
  	geocoder.geocode({'address': map_elm.data('address')}, function(results, status) {
		if (status === google.maps.GeocoderStatus.OK) { 
			map.setCenter(results[0].geometry.location);
			var marker = new google.maps.Marker({
				map: map,
				position: results[0].geometry.location,
				icon: map_elm.data('marker')
			});
			google.maps.event.addListener(marker, 'click', function () {
				window.location.href = 'https://www.google.com/maps/place/' + map_elm.data('address');
			});
		} else {
			alert('Geocode lookup was not successful for the following reason: ' + status);
		}
	});
	  
	map.mapTypes.set(customMapTypeId, customMapType);
	map.setMapTypeId(customMapTypeId);
}

jQuery( document ).ready(function( $ ) {
	/* Fish Species list shortcode slider */
	var no_of_items = $(".alvaro-species-slider-shortcode").data("items"),
		items_desktop = $(".alvaro-species-slider-shortcode").data("items_desktop"),
		items_desktop_small = $(".alvaro-species-slider-shortcode").data("items_desktop_small"),
		items_tablet = $(".alvaro-species-slider-shortcode").data("items_tablet"),
		items_mobile = $(".alvaro-species-slider-shortcode").data("items_mobile"),
		autoplay_vs = $(".alvaro-species-slider-shortcode").data("autoplay");
		
	$(".alvaro-species-slider-shortcode").owlCarousel({
		slideSpeed : 500,
		paginationSpeed : 500,
		items : no_of_items,
		itemsDesktop : [1170, items_desktop],
		itemsDesktopSmall : [979, items_desktop_small],
		itemsTablet: [768, items_tablet],
		itemsTabletSmall: false,
		itemsMobile : [479, items_mobile],
		
		// Autoplay
		autoPlay : autoplay_vs,
		stopOnHover : true,

		// Navigation
		navigation : true,
		navigationText: ['<i class="fa fa-chevron-left" aria-hidden="true"></i>', '<i class="fa fa-chevron-right" aria-hidden="true"></i>'],

		// Pagination
		pagination : false,
		autoHeight: false
	});
	
	/* Camping Locations list shortcode slider */
	var no_of_items = $(".alvaro-camping-locations-slider-shortcode").data("items"),
		items_desktop = $(".alvaro-camping-locations-slider-shortcode").data("items_desktop"),
		items_desktop_small = $(".alvaro-camping-locations-slider-shortcode").data("items_desktop_small"),
		items_tablet = $(".alvaro-camping-locations-slider-shortcode").data("items_tablet"),
		items_mobile = $(".alvaro-camping-locations-slider-shortcode").data("items_mobile"),
		autoplay_vs = $(".alvaro-camping-locations-slider-shortcode").data("autoplay");
		
	$(".alvaro-camping-locations-slider-shortcode").owlCarousel({
		slideSpeed : 500,
		paginationSpeed : 500,
		items : no_of_items,
		itemsDesktop : [1170, items_desktop],
		itemsDesktopSmall : [979, items_desktop_small],
		itemsTablet: [768, items_tablet],
		itemsTabletSmall: false,
		itemsMobile : [479, items_mobile],
		
		// Autoplay
		autoPlay : autoplay_vs,
		stopOnHover : true,

		// Navigation
		navigation : true,
		navigationText: ['<i class="fa fa-chevron-left" aria-hidden="true"></i>', '<i class="fa fa-chevron-right" aria-hidden="true"></i>'],

		// Pagination
		pagination : false,
		autoHeight: false
	});
	
	$('.HotspotPlugin_Hotspot').each(function(){
		var that = $(this);
		that.click(function(e){
			e.preventDefault();
			var ifa = that.find('i.fa');
			if( ifa.hasClass('fa-plus') ) {
				ifa.removeClass('fa-plus');
				ifa.addClass('fa-minus');
			} else {
				ifa.removeClass('fa-minus');
				ifa.addClass('fa-plus');
			}
			
		});
	});
	
	// init Google Map
	alvaro_google_map_elm = $('#alvaro-map');
	if( alvaro_google_map_elm.length > 0 ) {
		initAlvaroMap(alvaro_google_map_elm);
	}
	
	if( $('.aat-slideshow').length > 0 ) {
		jQuery(".aat-slideshow").each(function() {
			var this_element = jQuery(this),
                sliderTimeout = 1e3 * parseInt(this_element.attr("data-interval")),
                stopOnHover = this_element.attr("data-stop_on_hover"),
                showThumbs = this_element.attr("data-show_thumbs"),
                slideshow = !0;
			 
			0 === sliderTimeout && (slideshow = !1), this_element.is(":visible") && this_element.aatSlideshow({
			    'show_thumbs': true,
			    'number_thumbs': 3,
			    'autoPlay': slideshow,
			    'autoPlayTimeout': sliderTimeout,
			    'stopOnHover': stopOnHover,
			    'show_thumbs': showThumbs
			});
      });
	}
});